            #GIT_CMT=852dfcf93ba74cbfde5821ae609bee4cd10bc63f
%{!?buildid: %{expand: %%define buildid 2}}
%define module_name oracle-ucode-updates.ko
%define module %{module_dir}/%{module_name}
Summary: Loader for Oracle-specific microcode
Name: oracle-ucode-updates
Version: 0.1
Release:    4.el9
License: GPLv2 and Redistributable, no modification permitted

%define kernel7_ver 5.15.0-3.60.5.1%{dist}uek
%define module7_dir /lib/modules/%{kernel7_ver}.%{_arch}/extra/oracle/%{name}
%define module7 %{module7_dir}/%{module_name}
BuildRequires: kernel-uek-devel == %{kernel7_ver}

%define kernel8_ver 6.12.0-0.20.20%{dist}uek
%define module8_dir /lib/modules/%{kernel8_ver}.%{_arch}/extra/oracle/%{name}
%define module8 %{module8_dir}/%{module_name}
BuildRequires: kernel-uek-devel == %{kernel8_ver}

Requires: kmod
Requires: microcode_ctl
Group: Development/Debuggers
Vendor: Oracle America
ExclusiveOS: Linux
ExclusiveArch: x86_64
Source0: oracle-ucode-updates-0.1.tar.bz2
%global debug_package %{nil}
%define modsign_cmd ./mod-sign.sh

%define __modsign_install_post \
  %{modsign_cmd} \${RPM_BUILD_ROOT}
%define __spec_install_post \
  %{?__debug_package:%{__debug_install_post}}\
  %{__arch_install_post}\
  %{__os_install_post}\
  %{__modsign_install_post}

%define fw_dir /usr/lib/firmware/oracle-extra
BuildRequires:  systemd-units
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

%description
Oracle Linux special microcode loader

%prep
%setup %{name}-%{version}

%build
make KERNELDIR=/usr/src/kernels/%{kernel7_ver}.%{_arch}
mv %{module_name} ../oracle-ucode-updates-uek7.ko
make clean

source /opt/rh/gcc-toolset-14/enable
make KERNELDIR=/usr/src/kernels/%{kernel8_ver}.%{_arch}
mv %{module_name} ../oracle-ucode-updates-uek8.ko

%install
%{__install} -D -m644 ../oracle-ucode-updates-uek7.ko %{buildroot}/%{module7_dir}/%{module_name}
%{__install} -D -m644 ../oracle-ucode-updates-uek8.ko %{buildroot}/%{module8_dir}/%{module_name}

%{__install} -d -m755 %{buildroot}%{fw_dir}
for f in %{_builddir}/%{?buildsubdir}/microcode_amd_*.zip; do \
	unzip $f -d %{buildroot}%{fw_dir}; \
done

# systemd unit
install -m 755 -d "%{buildroot}/%{_unitdir}"
install -m 644 oracle-ucode-updates.service -t "%{buildroot}/%{_unitdir}/"

%post
echo %{module7} | weak-modules --no-initramfs --add-modules
echo %{module8} | weak-modules --no-initramfs --add-modules

%systemd_post oracle-ucode-updates.service
systemctl enable --now oracle-ucode-updates.service

%preun
%systemd_preun oracle-ucode-updates.service

%postun
%systemd_postun oracle-ucode-updates.service
if [[ "$1" == 0 ]]; then
	echo %{module} |  weak-modules --remove-modules --no-initramfs
fi

%files
%defattr(-,root,root)
%module7
%module8
%fw_dir
%{_unitdir}/oracle-ucode-updates.service
%license LICENSE.amd-ucode
%license LICENSE.txt

%changelog
* Wed Apr 30 2025 Alex Burmashev <alexander.burmashev@oracle.com> - 0.1-4.el9
- Add UEK8/OL9 build support (Boris Ostrovsky)  
- Make update_uci() static. (Boris Ostrovsky)  
- Open-code apic_id_is_primary_thread (Boris Ostrovsky)  
- Add Turin microcode (Boris Ostrovsky)  

* Wed Feb 5 2025 Alex Burmashev <alexander.burmashev@oracle.com> - 0.1-2.el9
- Do not return error if CPU vendor or FMS is not supported. (Boris Ostrovsky)

* Wed Jan 29 2025 Alex Burmashev <alexander.burmashev@oracle.com> - 0.1-1.el9
- Update signing scripts

* Mon Jan 27 2025 Boris Ostrovsky <boris.ostrovsky@oracle.com> - 0.1-1
- Initial package.

